﻿Partial Class DataGridViewDragAndDrop

    Protected Overrides Sub OnRowPrePaint(ByVal e As DataGridViewRowPrePaintEventArgs)
        If Not ShowRowNumbers Then Exit Sub
        e.PaintCells(e.ClipBounds, DataGridViewPaintParts.All)
        e.PaintHeader(DataGridViewPaintParts.Background Or
                      DataGridViewPaintParts.Border Or
                      DataGridViewPaintParts.Focus Or
                      DataGridViewPaintParts.SelectionBackground Or
                      DataGridViewPaintParts.ContentForeground)
        e.Handled = True
    End Sub

    Protected Overrides Sub OnCellFormatting(ByVal e As DataGridViewCellFormattingEventArgs)
        If Not ShowRowNumbers Then Exit Sub
        Dim rowNumber As String = (e.RowIndex + 1).ToString.PadLeft(RowCount.ToString.Length)
        Rows(e.RowIndex).HeaderCell.Value = rowNumber
    End Sub

End Class